diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/codel-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/codel-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/codel-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/codel-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -1329,23 +1329,27 @@
 {
   public:
     CoDelQueueDiscTestSuite()
-        : TestSuite("codel-queue-disc", UNIT)
+        : TestSuite("codel-queue-disc", Type::UNIT)
     {
         // Test 1: simple enqueue/dequeue with no drops
-        AddTestCase(new CoDelQueueDiscBasicEnqueueDequeue(QueueSizeUnit::PACKETS), TestCase::QUICK);
-        AddTestCase(new CoDelQueueDiscBasicEnqueueDequeue(QueueSizeUnit::BYTES), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicEnqueueDequeue(QueueSizeUnit::PACKETS),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicEnqueueDequeue(QueueSizeUnit::BYTES),
+                    TestCase::Duration::QUICK);
         // Test 2: enqueue with drops due to queue overflow
-        AddTestCase(new CoDelQueueDiscBasicOverflow(QueueSizeUnit::PACKETS), TestCase::QUICK);
-        AddTestCase(new CoDelQueueDiscBasicOverflow(QueueSizeUnit::BYTES), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicOverflow(QueueSizeUnit::PACKETS),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicOverflow(QueueSizeUnit::BYTES),
+                    TestCase::Duration::QUICK);
         // Test 3: test NewtonStep() against explicit port of Linux implementation
-        AddTestCase(new CoDelQueueDiscNewtonStepTest(), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscNewtonStepTest(), TestCase::Duration::QUICK);
         // Test 4: test ControlLaw() against explicit port of Linux implementation
-        AddTestCase(new CoDelQueueDiscControlLawTest(), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscControlLawTest(), TestCase::Duration::QUICK);
         // Test 5: enqueue/dequeue with drops according to CoDel algorithm
-        AddTestCase(new CoDelQueueDiscBasicDrop(QueueSizeUnit::PACKETS), TestCase::QUICK);
-        AddTestCase(new CoDelQueueDiscBasicDrop(QueueSizeUnit::BYTES), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicDrop(QueueSizeUnit::PACKETS), TestCase::Duration::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicDrop(QueueSizeUnit::BYTES), TestCase::Duration::QUICK);
         // Test 6: enqueue/dequeue with marks according to CoDel algorithm
-        AddTestCase(new CoDelQueueDiscBasicMark(QueueSizeUnit::PACKETS), TestCase::QUICK);
-        AddTestCase(new CoDelQueueDiscBasicMark(QueueSizeUnit::BYTES), TestCase::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicMark(QueueSizeUnit::PACKETS), TestCase::Duration::QUICK);
+        AddTestCase(new CoDelQueueDiscBasicMark(QueueSizeUnit::BYTES), TestCase::Duration::QUICK);
     }
 } g_coDelQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/fifo-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/fifo-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/fifo-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/fifo-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -274,8 +274,8 @@
 {
   public:
     FifoQueueDiscTestSuite()
-        : TestSuite("fifo-queue-disc", UNIT)
+        : TestSuite("fifo-queue-disc", Type::UNIT)
     {
-        AddTestCase(new FifoQueueDiscTestCase(), TestCase::QUICK);
+        AddTestCase(new FifoQueueDiscTestCase(), TestCase::Duration::QUICK);
     }
 } g_fifoQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/pie-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/pie-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/pie-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/pie-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -850,8 +850,8 @@
 {
   public:
     PieQueueDiscTestSuite()
-        : TestSuite("pie-queue-disc", UNIT)
+        : TestSuite("pie-queue-disc", Type::UNIT)
     {
-        AddTestCase(new PieQueueDiscTestCase(), TestCase::QUICK);
+        AddTestCase(new PieQueueDiscTestCase(), TestCase::Duration::QUICK);
     }
 } g_pieQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/prio-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/prio-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/prio-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/prio-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -322,8 +322,8 @@
 {
   public:
     PrioQueueDiscTestSuite()
-        : TestSuite("prio-queue-disc", UNIT)
+        : TestSuite("prio-queue-disc", Type::UNIT)
     {
-        AddTestCase(new PrioQueueDiscTestCase(), TestCase::QUICK);
+        AddTestCase(new PrioQueueDiscTestCase(), TestCase::Duration::QUICK);
     }
 } g_prioQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/queue-disc-traces-test-suite.cc ns-3.42/src/traffic-control/test/queue-disc-traces-test-suite.cc
--- ns-3.41/src/traffic-control/test/queue-disc-traces-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/queue-disc-traces-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -592,8 +592,8 @@
 {
   public:
     QueueDiscTracesTestSuite()
-        : TestSuite("queue-disc-traces", UNIT)
+        : TestSuite("queue-disc-traces", Type::UNIT)
     {
-        AddTestCase(new QueueDiscTracesTestCase(), TestCase::QUICK);
+        AddTestCase(new QueueDiscTracesTestCase(), TestCase::Duration::QUICK);
     }
 } g_queueDiscTracesTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/red-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/red-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/red-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/red-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -622,8 +622,8 @@
 {
   public:
     RedQueueDiscTestSuite()
-        : TestSuite("red-queue-disc", UNIT)
+        : TestSuite("red-queue-disc", Type::UNIT)
     {
-        AddTestCase(new RedQueueDiscTestCase(), TestCase::QUICK);
+        AddTestCase(new RedQueueDiscTestCase(), TestCase::Duration::QUICK);
     }
 } g_redQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/tbf-queue-disc-test-suite.cc ns-3.42/src/traffic-control/test/tbf-queue-disc-test-suite.cc
--- ns-3.41/src/traffic-control/test/tbf-queue-disc-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/tbf-queue-disc-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -546,8 +546,8 @@
 {
   public:
     TbfQueueDiscTestSuite()
-        : TestSuite("tbf-queue-disc", UNIT)
+        : TestSuite("tbf-queue-disc", Type::UNIT)
     {
-        AddTestCase(new TbfQueueDiscTestCase(), TestCase::QUICK);
+        AddTestCase(new TbfQueueDiscTestCase(), TestCase::Duration::QUICK);
     }
 } g_tbfQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/traffic-control/test/tc-flow-control-test-suite.cc ns-3.42/src/traffic-control/test/tc-flow-control-test-suite.cc
--- ns-3.41/src/traffic-control/test/tc-flow-control-test-suite.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/traffic-control/test/tc-flow-control-test-suite.cc	2024-05-29 15:29:47.184073700 -0700
@@ -501,20 +501,30 @@
 {
   public:
     TcFlowControlTestSuite()
-        : TestSuite("tc-flow-control", UNIT)
+        : TestSuite("tc-flow-control", Type::UNIT)
     {
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 1, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 5, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 9, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 10, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 11, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 15, 10), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 1, 1), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 2, 1), TestCase::QUICK);
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 5, 1), TestCase::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 1, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 5, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 9, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 10, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 11, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 15, 10),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 1, 1),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 2, 1),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::PACKETS, 5, 1),
+                    TestCase::Duration::QUICK);
 
         // TODO: Right now, this test only works for 5000B and 10 packets (it's hard coded). Should
         // also be made parametric.
-        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::BYTES, 5000, 10), TestCase::QUICK);
+        AddTestCase(new TcFlowControlTestCase(QueueSizeUnit::BYTES, 5000, 10),
+                    TestCase::Duration::QUICK);
     }
 } g_tcFlowControlTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/examples/uan-6lowpan-example.cc ns-3.42/src/uan/examples/uan-6lowpan-example.cc
--- ns-3.41/src/uan/examples/uan-6lowpan-example.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/uan/examples/uan-6lowpan-example.cc	2024-05-29 15:29:47.184073700 -0700
@@ -30,8 +30,10 @@
 #include "ns3/uan-helper.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
+ * \ingroup uan
  *
  * This example shows the usage of UDP over 6LoWPAN to transfer data.
  * Two nodes are sending their remaining energy percentage (1 byte)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/examples/uan-ipv4-example.cc ns-3.42/src/uan/examples/uan-ipv4-example.cc
--- ns-3.41/src/uan/examples/uan-ipv4-example.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/uan/examples/uan-ipv4-example.cc	2024-05-29 15:29:47.184073700 -0700
@@ -28,8 +28,10 @@
 #include "ns3/uan-helper.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
+ * \ingroup uan
  *
  * This example shows the usage of UDP over IPv4 to transfer data.
  * Two nodes are sending their remaining energy percentage (1 byte)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/examples/uan-ipv6-example.cc ns-3.42/src/uan/examples/uan-ipv6-example.cc
--- ns-3.41/src/uan/examples/uan-ipv6-example.cc	2024-02-09 14:44:08.537794600 -0800
+++ ns-3.42/src/uan/examples/uan-ipv6-example.cc	2024-05-29 15:29:47.184073700 -0700
@@ -28,8 +28,10 @@
 #include "ns3/uan-helper.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
+ * \ingroup uan
  *
  * This example shows the usage of UDP over IPv6 to transfer data.
  * Two nodes are sending their remaining energy percentage (1 byte)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/examples/uan-raw-example.cc ns-3.42/src/uan/examples/uan-raw-example.cc
--- ns-3.41/src/uan/examples/uan-raw-example.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/examples/uan-raw-example.cc	2024-05-29 15:29:47.184073700 -0700
@@ -32,6 +32,7 @@
 using namespace ns3;
 
 /**
+ * \ingroup uan
  *
  * This example shows the usage of raw packets transfer data.
  * Two nodes are sending their remaining energy percentage (1 byte)
@@ -130,11 +131,11 @@
     Ptr<UanChannel> channel = CreateObject<UanChannel>();
     UanHelper uanHelper;
     NetDeviceContainer netDeviceContainer = uanHelper.Install(m_nodes, channel);
-    EnergySourceContainer energySourceContainer;
+    energy::EnergySourceContainer energySourceContainer;
     auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
-        energySourceContainer.Add((*node)->GetObject<EnergySourceContainer>()->Get(0));
+        energySourceContainer.Add((*node)->GetObject<energy::EnergySourceContainer>()->Get(0));
         node++;
     }
     AcousticModemEnergyModelHelper acousticModemEnergyModelHelper;
@@ -193,7 +194,8 @@
     while (node != m_nodes.End())
     {
         uint8_t energy =
-            ((*node)->GetObject<EnergySourceContainer>()->Get(0)->GetEnergyFraction()) * 100;
+            ((*node)->GetObject<energy::EnergySourceContainer>()->Get(0)->GetEnergyFraction()) *
+            100;
 
         Ptr<Packet> pkt = Create<Packet>(&energy, 1);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/examples/uan-rc-example.cc ns-3.42/src/uan/examples/uan-rc-example.cc
--- ns-3.41/src/uan/examples/uan-rc-example.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/examples/uan-rc-example.cc	2024-05-29 15:29:47.184073700 -0700
@@ -19,7 +19,8 @@
 
 /**
  * \file uan-rc-example.cc
- * \ingroup UAN
+ * \ingroup uan
+ *
  * This example uses UanMacRc and UanMacRcGw which combined form a system
  * using what is referred to as RC-MAC.  Details of RC-MAC will be published
  * soon.  In brief terms, RC-MAC is a dual channel protocol wherein the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/helper/acoustic-modem-energy-model-helper.cc ns-3.42/src/uan/helper/acoustic-modem-energy-model-helper.cc
--- ns-3.41/src/uan/helper/acoustic-modem-energy-model-helper.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/helper/acoustic-modem-energy-model-helper.cc	2024-05-29 15:29:47.184073700 -0700
@@ -55,8 +55,9 @@
  * Private function starts here.
  */
 
-Ptr<DeviceEnergyModel>
-AcousticModemEnergyModelHelper::DoInstall(Ptr<NetDevice> device, Ptr<EnergySource> source) const
+Ptr<energy::DeviceEnergyModel>
+AcousticModemEnergyModelHelper::DoInstall(Ptr<NetDevice> device,
+                                          Ptr<energy::EnergySource> source) const
 {
     NS_ASSERT(device);
     NS_ASSERT(source);
@@ -83,8 +84,8 @@
     // set node pointer
     source->SetNode(node);
     // create and install energy model callback
-    DeviceEnergyModel::ChangeStateCallback cb;
-    cb = MakeCallback(&DeviceEnergyModel::ChangeState, model);
+    energy::DeviceEnergyModel::ChangeStateCallback cb;
+    cb = MakeCallback(&energy::DeviceEnergyModel::ChangeState, model);
     uanPhy->SetEnergyModelCallback(cb);
 
     return model;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/helper/acoustic-modem-energy-model-helper.h ns-3.42/src/uan/helper/acoustic-modem-energy-model-helper.h
--- ns-3.41/src/uan/helper/acoustic-modem-energy-model-helper.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/helper/acoustic-modem-energy-model-helper.h	2024-05-29 15:29:47.184073700 -0700
@@ -71,8 +71,8 @@
      * \param source Pointer to EnergySource installed on node.
      * \return The energy model.
      */
-    Ptr<DeviceEnergyModel> DoInstall(Ptr<NetDevice> device,
-                                     Ptr<EnergySource> source) const override;
+    Ptr<energy::DeviceEnergyModel> DoInstall(Ptr<NetDevice> device,
+                                             Ptr<energy::EnergySource> source) const override;
 
   private:
     /** Energy model factory. */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/acoustic-modem-energy-model.cc ns-3.42/src/uan/model/acoustic-modem-energy-model.cc
--- ns-3.41/src/uan/model/acoustic-modem-energy-model.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/acoustic-modem-energy-model.cc	2024-05-29 15:29:47.184073700 -0700
@@ -40,7 +40,7 @@
 {
     static TypeId tid =
         TypeId("ns3::AcousticModemEnergyModel")
-            .SetParent<DeviceEnergyModel>()
+            .SetParent<energy::DeviceEnergyModel>()
             .AddConstructor<AcousticModemEnergyModel>()
             .AddAttribute("TxPowerW",
                           "The modem Tx power in Watts",
@@ -103,7 +103,7 @@
 }
 
 void
-AcousticModemEnergyModel::SetEnergySource(Ptr<EnergySource> source)
+AcousticModemEnergyModel::SetEnergySource(Ptr<energy::EnergySource> source)
 {
     NS_LOG_FUNCTION(this << source);
     NS_ASSERT(source);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/acoustic-modem-energy-model.h ns-3.42/src/uan/model/acoustic-modem-energy-model.h
--- ns-3.41/src/uan/model/acoustic-modem-energy-model.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/acoustic-modem-energy-model.h	2024-05-29 15:29:47.184073700 -0700
@@ -52,7 +52,7 @@
  *     in In Proc. IEEE OCEANS05 Conf, 2005.
  *     URL: http://ieeexplore.ieee.org/iel5/10918/34367/01639901.pdf
  */
-class AcousticModemEnergyModel : public DeviceEnergyModel
+class AcousticModemEnergyModel : public energy::DeviceEnergyModel
 {
   public:
     /** Callback type for energy depletion handling. */
@@ -87,7 +87,7 @@
     virtual Ptr<Node> GetNode() const;
 
     // Inherited methods.
-    void SetEnergySource(Ptr<EnergySource> source) override;
+    void SetEnergySource(Ptr<energy::EnergySource> source) override;
     double GetTotalEnergyConsumption() const override;
 
     /**
@@ -216,8 +216,8 @@
     void SetMicroModemState(const int state);
 
   private:
-    Ptr<Node> m_node;           //!< The node hosting this transducer.
-    Ptr<EnergySource> m_source; //!< The energy source.
+    Ptr<Node> m_node;                   //!< The node hosting this transducer.
+    Ptr<energy::EnergySource> m_source; //!< The energy source.
 
     // Member variables for power consumption in different modem states.
     double m_txPowerW;    //!< The transmitter power, in watts.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-header-common.cc ns-3.42/src/uan/model/uan-header-common.cc
--- ns-3.41/src/uan/model/uan-header-common.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-header-common.cc	2024-05-29 15:29:47.184073700 -0700
@@ -24,6 +24,7 @@
 static const uint16_t ARP_PROT_NUMBER = 0x0806;
 static const uint16_t IPV4_PROT_NUMBER = 0x0800;
 static const uint16_t IPV6_PROT_NUMBER = 0x86DD;
+static const uint16_t SIXLOWPAN_PROT_NUMBER = 0xA0ED;
 
 namespace ns3
 {
@@ -103,6 +104,10 @@
     {
         m_uanProtocolBits.m_protocolNumber = 3;
     }
+    else if (protocolNumber == SIXLOWPAN_PROT_NUMBER)
+    {
+        m_uanProtocolBits.m_protocolNumber = 4;
+    }
     else
     {
         NS_ASSERT_MSG(false, "UanHeaderCommon::SetProtocolNumber(): Protocol not supported");
@@ -142,6 +147,10 @@
     {
         return IPV6_PROT_NUMBER;
     }
+    if (m_uanProtocolBits.m_protocolNumber == 4)
+    {
+        return SIXLOWPAN_PROT_NUMBER;
+    }
     return 0;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-header-common.h ns-3.42/src/uan/model/uan-header-common.h
--- ns-3.41/src/uan/model/uan-header-common.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-header-common.h	2024-05-29 15:29:47.184073700 -0700
@@ -58,6 +58,7 @@
  * prtcl=1 (IPv4)
  * prtcl=2 (ARP)
  * prtcl=3 (IPv6)
+ * prtcl=4 (6LoWPAN)
  *
  * type: The type field is MAC protocol specific
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-mac-rc.cc ns-3.42/src/uan/model/uan-mac-rc.cc
--- ns-3.41/src/uan/model/uan-mac-rc.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-mac-rc.cc	2024-05-29 15:29:47.184073700 -0700
@@ -294,7 +294,7 @@
         Associate();
         return true;
     case IDLE:
-        if (!m_rtsEvent.IsRunning())
+        if (!m_rtsEvent.IsPending())
         {
             SendRts();
         }
@@ -489,7 +489,7 @@
     m_state = IDLE;
     if (!m_pktQueue.empty())
     {
-        if (m_rtsEvent.IsRunning())
+        if (m_rtsEvent.IsPending())
         {
             m_rtsEvent.Cancel();
         }
@@ -625,7 +625,7 @@
         SendPacket(pkt, m_currentRate + m_numRates);
     }
     m_state = GWPSENT;
-    NS_ASSERT(!m_rtsEvent.IsRunning());
+    NS_ASSERT(!m_rtsEvent.IsPending());
     m_ev->SetAttribute("Mean", DoubleValue(1 / m_retryRate));
     double timeout = m_ev->GetValue();
     m_rtsEvent = Simulator::Schedule(Seconds(timeout), &UanMacRc::AssociateTimeout, this);
@@ -659,7 +659,7 @@
         SendPacket(pkt, m_currentRate + m_numRates);
         m_resList.push_back(res);
     }
-    NS_ASSERT(!m_rtsEvent.IsRunning());
+    NS_ASSERT(!m_rtsEvent.IsPending());
     m_ev->SetAttribute("Mean", DoubleValue(1 / m_retryRate));
     double timeout = m_ev->GetValue();
     m_rtsEvent = Simulator::Schedule(Seconds(timeout), &UanMacRc::AssociateTimeout, this);
@@ -693,7 +693,7 @@
         SendPacket(pkt, m_currentRate + m_numRates);
     }
     m_state = RTSSENT;
-    NS_ASSERT(!m_rtsEvent.IsRunning());
+    NS_ASSERT(!m_rtsEvent.IsPending());
     m_ev->SetAttribute("Mean", DoubleValue(1 / m_retryRate));
     double timeout = m_ev->GetValue();
     m_rtsEvent = Simulator::Schedule(Seconds(timeout), &UanMacRc::RtsTimeout, this);
@@ -711,11 +711,8 @@
         Ptr<Packet> pkt = phyDual->GetPhy1PacketRx();
         UanHeaderCommon ch;
         pkt->PeekHeader(ch);
-        if (ch.GetType() == TYPE_CTS || ch.GetType() == TYPE_ACK)
-        {
-            phy1ok = false;
-        }
-        else if (ch.GetDest() == Mac8Address::ConvertFrom(GetAddress()))
+        if (ch.GetType() == TYPE_CTS || ch.GetType() == TYPE_ACK ||
+            ch.GetDest() == Mac8Address::ConvertFrom(GetAddress()))
         {
             phy1ok = false;
         }
@@ -758,7 +755,7 @@
         SendPacket(pkt, m_currentRate + m_numRates);
     }
     m_state = RTSSENT;
-    NS_ASSERT(!m_rtsEvent.IsRunning());
+    NS_ASSERT(!m_rtsEvent.IsPending());
     m_ev->SetAttribute("Mean", DoubleValue(1 / m_retryRate));
     double timeout = m_ev->GetValue();
     m_rtsEvent = Simulator::Schedule(Seconds(timeout), &UanMacRc::RtsTimeout, this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-phy-dual.cc ns-3.42/src/uan/model/uan-phy-dual.cc
--- ns-3.41/src/uan/model/uan-phy-dual.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-phy-dual.cc	2024-05-29 15:29:47.184073700 -0700
@@ -251,7 +251,7 @@
 }
 
 void
-UanPhyDual::SetEnergyModelCallback(DeviceEnergyModel::ChangeStateCallback callback)
+UanPhyDual::SetEnergyModelCallback(energy::DeviceEnergyModel::ChangeStateCallback callback)
 {
     NS_LOG_DEBUG("Not Implemented");
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-phy-dual.h ns-3.42/src/uan/model/uan-phy-dual.h
--- ns-3.41/src/uan/model/uan-phy-dual.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-phy-dual.h	2024-05-29 15:29:47.184073700 -0700
@@ -90,7 +90,7 @@
     static TypeId GetTypeId();
 
     // Inherited methods:
-    void SetEnergyModelCallback(DeviceEnergyModel::ChangeStateCallback callback) override;
+    void SetEnergyModelCallback(energy::DeviceEnergyModel::ChangeStateCallback callback) override;
     void EnergyDepletionHandler() override;
     void EnergyRechargeHandler() override;
     void SendPacket(Ptr<Packet> pkt, uint32_t modeNum) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-phy-gen.cc ns-3.42/src/uan/model/uan-phy-gen.cc
--- ns-3.41/src/uan/model/uan-phy-gen.cc	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-phy-gen.cc	2024-05-29 15:29:47.184073700 -0700
@@ -631,7 +631,7 @@
 }
 
 void
-UanPhyGen::SetEnergyModelCallback(DeviceEnergyModel::ChangeStateCallback cb)
+UanPhyGen::SetEnergyModelCallback(energy::DeviceEnergyModel::ChangeStateCallback cb)
 {
     NS_LOG_FUNCTION(this);
     m_energyCallback = cb;
@@ -656,13 +656,13 @@
                                             << ", stopping rx/tx activities");
 
     m_state = DISABLED;
-    if (m_txEndEvent.IsRunning())
+    if (m_txEndEvent.IsPending())
     {
         Simulator::Cancel(m_txEndEvent);
         NotifyTxDrop(m_pktTx);
         m_pktTx = nullptr;
     }
-    if (m_rxEndEvent.IsRunning())
+    if (m_rxEndEvent.IsPending())
     {
         Simulator::Cancel(m_rxEndEvent);
         NotifyRxDrop(m_pktRx);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-phy-gen.h ns-3.42/src/uan/model/uan-phy-gen.h
--- ns-3.41/src/uan/model/uan-phy-gen.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-phy-gen.h	2024-05-29 15:29:47.184073700 -0700
@@ -278,7 +278,7 @@
     static TypeId GetTypeId();
 
     // Inherited methods
-    void SetEnergyModelCallback(DeviceEnergyModel::ChangeStateCallback cb) override;
+    void SetEnergyModelCallback(energy::DeviceEnergyModel::ChangeStateCallback cb) override;
     void EnergyDepletionHandler() override;
     void EnergyRechargeHandler() override;
     void SendPacket(Ptr<Packet> pkt, uint32_t modeNum) override;
@@ -352,7 +352,7 @@
     Ptr<UniformRandomVariable> m_pg;
 
     /** Energy model callback. */
-    DeviceEnergyModel::ChangeStateCallback m_energyCallback;
+    energy::DeviceEnergyModel::ChangeStateCallback m_energyCallback;
     /** A packet destined for this Phy was received without error. */
     ns3::TracedCallback<Ptr<const Packet>, double, UanTxMode> m_rxOkLogger;
     /** A packet destined for this Phy was received with error. */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/model/uan-phy.h ns-3.42/src/uan/model/uan-phy.h
--- ns-3.41/src/uan/model/uan-phy.h	2024-02-09 14:44:08.557794800 -0800
+++ ns-3.42/src/uan/model/uan-phy.h	2024-05-29 15:29:47.184073700 -0700
@@ -219,7 +219,8 @@
      *
      * \param callback The DeviceEnergyModel change state callback.
      */
-    virtual void SetEnergyModelCallback(DeviceEnergyModel::ChangeStateCallback callback) = 0;
+    virtual void SetEnergyModelCallback(
+        energy::DeviceEnergyModel::ChangeStateCallback callback) = 0;
     /**
      * Handle the energy depletion event.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/test/uan-energy-model-test.cc ns-3.42/src/uan/test/uan-energy-model-test.cc
--- ns-3.41/src/uan/test/uan-energy-model-test.cc	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/uan/test/uan-energy-model-test.cc	2024-05-29 15:29:47.188073900 -0700
@@ -36,6 +36,7 @@
 #include "ns3/uan-prop-model-ideal.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("UanEnergyModelTestSuite");
 
@@ -334,10 +335,10 @@
 };
 
 UanEnergyModelTestSuite::UanEnergyModelTestSuite()
-    : TestSuite("uan-energy-model", UNIT)
+    : TestSuite("uan-energy-model", Type::UNIT)
 {
-    AddTestCase(new AcousticModemEnergyTestCase, TestCase::QUICK);
-    AddTestCase(new AcousticModemEnergyDepletionTestCase, TestCase::QUICK);
+    AddTestCase(new AcousticModemEnergyTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new AcousticModemEnergyDepletionTestCase, TestCase::Duration::QUICK);
 }
 
 // create an instance of the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/uan/test/uan-test.cc ns-3.42/src/uan/test/uan-test.cc
--- ns-3.41/src/uan/test/uan-test.cc	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/uan/test/uan-test.cc	2024-05-29 15:29:47.188073900 -0700
@@ -323,9 +323,9 @@
 };
 
 UanTestSuite::UanTestSuite()
-    : TestSuite("devices-uan", UNIT)
+    : TestSuite("devices-uan", Type::UNIT)
 {
-    AddTestCase(new UanTest, TestCase::QUICK);
+    AddTestCase(new UanTest, TestCase::Duration::QUICK);
 }
 
 static UanTestSuite g_uanTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/virtual-net-device/model/virtual-net-device.cc ns-3.42/src/virtual-net-device/model/virtual-net-device.cc
--- ns-3.41/src/virtual-net-device/model/virtual-net-device.cc	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/virtual-net-device/model/virtual-net-device.cc	2024-05-29 15:29:47.188073900 -0700
@@ -224,7 +224,7 @@
 Address
 VirtualNetDevice::GetBroadcast() const
 {
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 bool
@@ -236,13 +236,13 @@
 Address
 VirtualNetDevice::GetMulticast(Ipv4Address multicastGroup) const
 {
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 Address
 VirtualNetDevice::GetMulticast(Ipv6Address addr) const
 {
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/model/pyviz.cc ns-3.42/src/visualizer/model/pyviz.cc
--- ns-3.41/src/visualizer/model/pyviz.cc	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/model/pyviz.cc	2024-05-29 15:29:47.188073900 -0700
@@ -601,21 +601,13 @@
     WifiMacHeader hdr;
     NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
     Mac48Address destinationAddress;
-    if (hdr.IsToDs() && !hdr.IsFromDs())
+    if (hdr.IsToDs())
     {
         destinationAddress = hdr.GetAddr3();
     }
-    else if (!hdr.IsToDs() && hdr.IsFromDs())
-    {
-        destinationAddress = hdr.GetAddr1();
-    }
-    else if (!hdr.IsToDs() && !hdr.IsFromDs())
-    {
-        destinationAddress = hdr.GetAddr1();
-    }
     else
     {
-        destinationAddress = hdr.GetAddr3();
+        destinationAddress = hdr.GetAddr1();
     }
     TraceNetDevTxCommon(context, packet, destinationAddress);
 }
@@ -769,19 +761,15 @@
     WifiMacHeader hdr;
     NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
     Mac48Address sourceAddress;
-    if (hdr.IsToDs() && !hdr.IsFromDs())
+    if (!hdr.IsFromDs())
     {
         sourceAddress = hdr.GetAddr2();
     }
-    else if (!hdr.IsToDs() && hdr.IsFromDs())
+    else if (!hdr.IsToDs())
     {
         sourceAddress = hdr.GetAddr3();
     }
-    else if (!hdr.IsToDs() && !hdr.IsFromDs())
-    {
-        sourceAddress = hdr.GetAddr2();
-    }
-    else
+    else // if (hdr.IsToDs())
     {
         sourceAddress = hdr.GetAddr4();
     }
